/*******************************************************************************
 * Copyright (c) 2007-2013 THALES GLOBAL SERVICES.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 *******************************************************************************/
package org.eclipse.sirius.tree.description;

import org.eclipse.emf.common.util.EList;
import org.eclipse.sirius.viewpoint.description.tool.MappingBasedToolDescription;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Tree Item Creation Tool</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.sirius.tree.description.TreeItemCreationTool#getMapping
 * <em>Mapping</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.sirius.tree.description.DescriptionPackage#getTreeItemCreationTool()
 * @model
 * @generated
 */
public interface TreeItemCreationTool extends TreeItemTool, MappingBasedToolDescription {
    /**
     * Returns the value of the '<em><b>Mapping</b></em>' reference list. The
     * list contents are of type
     * {@link org.eclipse.sirius.tree.description.TreeItemMapping}. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Mapping</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Mapping</em>' reference list.
     * @see org.eclipse.sirius.tree.description.DescriptionPackage#getTreeItemCreationTool_Mapping()
     * @model
     * @generated
     */
    EList<TreeItemMapping> getMapping();

} // TreeItemCreationTool
